import tkinter
import random

key = ''
koff = False

def key_down(e):
    global key, koff
    key = e.keysym
    koff = False

def key_up(e):
    global koff
    koff = True

DIR_UP = 0
DIR_DOWN = 1
DIR_LEFT = 2
DIR_RIGHT = 3
ANIMATION = [0, 1, 0, 2]

tmr = 0
score = 0

pen_x = 90
pen_y = 90
pen_d = 0
pen_a = 0

red_x = 630
red_y = 450
red_d = 0
red_a = 0

map_data = [
[0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0],
[0, 2, 3, 3, 2, 1, 1, 2, 3, 3, 2, 0],
[0, 3, 0, 0, 3, 3, 3, 3, 0, 0, 3, 0],
[0, 3, 1, 1, 3, 0, 0, 3, 1, 1, 3, 0],
[0, 3, 2, 2, 3, 0, 0, 3, 2, 2, 3, 0],
[0, 3, 0, 0, 3, 1, 1, 3, 0, 0, 3, 0],
[0, 3, 1, 1, 3, 3, 3, 3, 1, 1, 3, 0],
[0, 2, 3, 3, 2, 0, 0, 2, 3, 3, 2, 0],
[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
]

def draw_txt(txt, x, y, siz, col):
    fnt = ('Times New Roman', siz, 'bold')
    canvas.create_text(x + 2, y + 2, text = txt, fill = 'black', font = fnt, tag = 'SCREEN')
    canvas.create_text(x, y, text = txt, fill = col, font = fnt, tag = 'SCREEN')

def draw_screen():
    canvas.delete('SCREEN')
    for y in range(9):
        for x in range(12):
            canvas.create_image(x * 60 + 30, y * 60 + 30, image = img_bg[map_data[y][x]], tag = 'SCREEN')
    canvas.create_image(pen_x, pen_y, image = img_pen[pen_a], tag = 'SCREEN')
    canvas.create_image(red_x, red_y, image = img_red[red_a], tag = 'SCREEN')
    draw_txt('SCORE ' + str(score), 200, 30, 30, 'white')

def check_wall(cx, cy, di, dot):
    chk = False
    if di == DIR_UP:
        mx = int((cx - 30) / 60)
        my = int((cy - 30 - dot) / 60)
        if map_data[my][mx] <= 1:
            chk = True
        mx = int((cx + 29) / 60)
        if map_data[my][mx] <= 1:
            chk = True
    if di == DIR_DOWN:
        mx = int((cx - 30) / 60)
        my = int((cy + 29 + dot) / 60)
        if map_data[my][mx] <= 1:
            chk = True
        mx = int((cx + 29) / 60)
        if map_data[my][mx] <= 1:
            chk = True
    if di == DIR_LEFT:
        mx = int((cx - 30 - dot) / 60)
        my = int((cy - 30) / 60)
        if map_data[my][mx] <= 1:
            chk = True
        my = int((cy + 29) / 60)
        if map_data[my][mx] <= 1:
            chk = True
    if di == DIR_RIGHT:
        mx = int((cx + 29 + dot) / 60)
        my = int((cy - 30) / 60)
        if map_data[my][mx] <= 1:
            chk = True
        my = int((cy + 29) / 60)
        if map_data[my][mx] <= 1:
            chk = True
    return chk

def move_penpen():
    global score, pen_x, pen_y, pen_d, pen_a
    if key == 'Up':
        pen_d = DIR_UP
        if check_wall(pen_x, pen_y, pen_d, 20) == False:
            pen_y = pen_y - 20
    if key == 'Down':
        pen_d = DIR_DOWN
        if check_wall(pen_x, pen_y, pen_d, 20) == False:
            pen_y = pen_y + 20
    if key == 'Left':
        pen_d = DIR_LEFT
        if check_wall(pen_x, pen_y, pen_d, 20) == False:
            pen_x = pen_x - 20
    if key == 'Right':
        pen_d = DIR_RIGHT
        if check_wall(pen_x, pen_y, pen_d, 20) == False:
            pen_x = pen_x + 20
    pen_a = pen_d * 3 + ANIMATION[tmr % 4]
    mx = int(pen_x / 60)
    my = int(pen_y / 60)
    if map_data[my][mx] == 3:
        score = score + 100
        map_data[my][mx] = 2

def move_enemy():
    global red_x, red_y, red_d, red_a
    speed = 10
    if red_x % 60 == 30 and red_y % 60 == 30:
        red_d = random.randint(0, 3)
    if red_d == DIR_UP:
        if check_wall(red_x, red_y, red_d, speed) == False:
            red_y = red_y - speed
    if red_d == DIR_DOWN:
        if check_wall(red_x, red_y, red_d, speed) == False:
            red_y = red_y + speed
    if red_d == DIR_LEFT:
        if check_wall(red_x, red_y, red_d, speed) == False:
            red_x = red_x - speed
    if red_d == DIR_RIGHT:
        if check_wall(red_x, red_y, red_d, speed) == False:
            red_x = red_x + speed
    red_a = red_d * 3 + ANIMATION[tmr % 4]

def main():
    global key, koff, tmr
    tmr = tmr + 1
    draw_screen()
    move_penpen()
    move_enemy()
    if koff == True:
        key = ''
        koff = False
    root.after(100, main)

root = tkinter.Tk()

img_bg = [
    tkinter.PhotoImage(file = 'images/chip00.png'),
    tkinter.PhotoImage(file = 'images/chip01.png'),
    tkinter.PhotoImage(file = 'images/chip02.png'),
    tkinter.PhotoImage(file = 'images/chip03.png')
]

img_pen = [
    tkinter.PhotoImage(file = 'images/pen00.png'),
    tkinter.PhotoImage(file = 'images/pen01.png'),
    tkinter.PhotoImage(file = 'images/pen02.png'),
    tkinter.PhotoImage(file = 'images/pen03.png'),
    tkinter.PhotoImage(file = 'images/pen04.png'),
    tkinter.PhotoImage(file = 'images/pen05.png'),
    tkinter.PhotoImage(file = 'images/pen06.png'),
    tkinter.PhotoImage(file = 'images/pen07.png'),
    tkinter.PhotoImage(file = 'images/pen08.png'),
    tkinter.PhotoImage(file = 'images/pen09.png'),
    tkinter.PhotoImage(file = 'images/pen10.png'),
    tkinter.PhotoImage(file = 'images/pen11.png')
]

img_red = [
    tkinter.PhotoImage(file = 'images/red00.png'),
    tkinter.PhotoImage(file = 'images/red01.png'),
    tkinter.PhotoImage(file = 'images/red02.png'),
    tkinter.PhotoImage(file = 'images/red03.png'),
    tkinter.PhotoImage(file = 'images/red04.png'),
    tkinter.PhotoImage(file = 'images/red05.png'),
    tkinter.PhotoImage(file = 'images/red06.png'),
    tkinter.PhotoImage(file = 'images/red07.png'),
    tkinter.PhotoImage(file = 'images/red08.png'),
    tkinter.PhotoImage(file = 'images/red09.png'),
    tkinter.PhotoImage(file = 'images/red10.png'),
    tkinter.PhotoImage(file = 'images/red11.png')
]

root.title('提心吊膽企鵝迷宮')
root.resizable(False, False)
root.bind('<KeyPress>', key_down)
root.bind('<KeyRelease>', key_up)
canvas = tkinter.Canvas(width = 720, height = 540)
canvas.pack()
main()
root.mainloop()